<!doctype html>
<html lang="en">

<head>
    <title>Title</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
        integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- DataTable -->
    <!--  -->
    <!-- Import DataTable Library -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <!-- Awesome-font -->
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.15.4/css/all.css"
        integrity="sha384-DyZ88mC6Up2uqS4h/KRgHuoeGwBcD4Ng9SiP4dIRy0EXTlnuz47vAwmeGwVChigm" crossorigin="anonymous" />
    <!-- <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css"> -->
</head>

<body>
    <div class="container-fluid">
        <h1 class="text-center my-2">Danh Sách đơn hàng</h1>
        <div class="jumbotron">
            <div class="row">
                <div class="col-sm-2 text-right">
                    <label for="">Trạng thái Order</label>

                </div>
                <div class="col-sm-3">
                    <select name="" id="select-status" class="form-control">
                        <option value="">Chọn trạng thái</option>
                    </select>
                </div>
                <div class="col-sm-2 text-right">
                    <label for="">Loại Pizza</label>

                </div>
                <div class="col-sm-3">
                    <select name="" id="select-type-pizza" class="form-control">
                        <option value="">Chọn loại pizza</option>
                    </select>
                </div>
                <div class="col-sm-2">
                    <button id="btn-filter" class="btn btn-success form-control"><i
                            class="fas fa-filter mr-2"></i>Lọc</button>
                </div>
            </div>

        </div>

        <table id="table-order" class="table table-bordered table-striped">
            <thead>
                <tr>
                    <th>OrderCode</th>
                    <th>Kích cỡ combo</th>
                    <th>Loại Pizza</th>
                    <th>Nước uống</th>
                    <th>Thành tiền</th>
                    <th>Họ và tên</th>
                    <th>Số điện thoại</th>
                    <th>Trạng thái</th>
                    <th>Chi tiết</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>

    </div>
    <!-- modal -->
    <div id="modal-detail" class="modal" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">OrderDetail!!!!</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="row">
                        <div class="col-sm-3">
                            <label for="">OrderCode</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-order-code" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Pizza Size</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <select name="" id="select-size" class="form-control">
                                <option value="">Chọn size</option>
                                <option value="">S</option>
                                <option value="">M</option>
                                <option value="">L</option>
                            </select>
                        </div>
                        <div class="col-sm-3">
                            <label for="">Đường kính</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-duong-kinh" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Sườn </label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-suon" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Salad</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-salad" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Pizza Type</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-loai-pizza" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Id Voucher</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-id-voucher" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Thành Tiền</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-thanh-tien" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Giảm giá</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-giam-gia" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Số lượng nước </label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-so-luong-nuoc" class="form-control">
                        </div>

                        <div class="col-sm-3">
                            <label for="">Loại nước uống</label>

                        </div>
                        <div class="col-sm-9 mb-3">
                            <select name="" id="select-drink" class="form-control">
                                <option value="">Chọn loại nước uống</option>
                            </select>
                        </div>
                        <div class="col-sm-3">
                            <label for="">Họ tên</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-ho-ten" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Email</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-email" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Sô điện thoại</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-so-dien-thoai" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Địa chỉ</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-dia-chi" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Lời nhắn</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-loi-nhan" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Ngày order</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-ngay-order" class="form-control">
                        </div>
                        <div class="col-sm-3">
                            <label for="">Ngày chỉnh sửa</label>
                        </div>
                        <div class="col-sm-9 mb-3">
                            <input type="text" name="" id="inp-ngay-sua" class="form-control">
                        </div>
                    </div>

                </div>
                <div class="">
                    <div class="row my-3 mx-3">
                        <div class="col-sm-6">
                            <button id="btn-confirm" type="button" class="btn btn-warning form-control">Confirm</button>
                        </div>
                        <div class="col-sm-6">
                            <button id="btn-cancel" type="button" class="btn btn-danger form-control">Cancel</button>
                        </div>
                    </div>


                </div>
            </div>
        </div>
    </div>
    <!-- end modal -->


</body>
<script>
    "user strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    const gBASE_URL_DRINk = "http://203.171.20.210:8080/devcamp-pizza365/drinks";
    const gCONTENT_TYPE = "application/json;charset=UTF-8";
    const gCOL_NAME = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
    const gCOL_ORDER_CODE = 0;
    const gCOL_KICH_CO = 1;
    const gCOL_LOAI_PIZZA = 2;
    const gCOL_ID_LOAI_NUOC_UONG = 3;
    const gCOL_THANH_TIEN = 4;
    const gCOL_HO_TEN = 5;
    const gCOL_SO_DIEN_THOAI = 6;
    const gCOL_TRANG_THAI = 7;
    const gCOL_ACTION = 8;
    var gDataOrder = [];
    var gOrderCode = "";
    var gId = "";

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
        onDataTable();
        onPageLoading();
        loadDataSelectStatus();
        loadDataSelectTypePizza();

        $("#table-order").on("click", ".btn-detail", function () {
            gOrderCode = getDataButtonTable(this).orderCode;
            gId = getDataButtonTable(this).id;
            $("#modal-detail").modal().show;
            onLoadDrink();
            onLoadDataModal();
        })
        $("#btn-filter").on("click", function () {
            onBtnFilter();


        })
        $("#btn-confirm").on("click", function () {
            onBtnUpdateModalConfirm();
        })
        $("#btn-cancel").on("click", function () {
            onBtnUpdateModalCancel();
        })
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onDataTable() {
        $("#table-order").DataTable({
            columns: [
                { data: gCOL_NAME[gCOL_ORDER_CODE] },
                { data: gCOL_NAME[gCOL_KICH_CO] },
                { data: gCOL_NAME[gCOL_LOAI_PIZZA] },
                { data: gCOL_NAME[gCOL_ID_LOAI_NUOC_UONG] },
                { data: gCOL_NAME[gCOL_THANH_TIEN] },
                { data: gCOL_NAME[gCOL_HO_TEN] },
                { data: gCOL_NAME[gCOL_SO_DIEN_THOAI] },
                { data: gCOL_NAME[gCOL_TRANG_THAI] },
                { data: gCOL_NAME[gCOL_ACTION] },

            ],
            columnDefs: [
                {
                    targets: gCOL_ACTION,
                    defaultContent: '<button class="btn btn-info btn-detail">Chi Tiết</button>'
                }
            ]
        })
    }

    function onPageLoading() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            success: function (paramRes) {
                console.log(paramRes);
                gDataOrder = paramRes;
                loadDataToTable(paramRes);

            },
            error: function (paramErr) {
                console.log(paramErr.status)
            },
        })
    }
    // load data select 
    function loadDataSelectStatus() {
        var vArrayTrangThai = ["open", "confirmed", "cancel"];
        for (var bI = 0; bI < vArrayTrangThai.length; bI++) {
            $("#select-status").append($("<option>", {
                text: vArrayTrangThai[bI],
                value: vArrayTrangThai[bI].toUpperCase(),
            }))
        }

    }
    function loadDataSelectTypePizza() {
        var vArrayPizza = ["hawaii", "bacon", "seafood"];
        for (var bI = 0; bI < vArrayPizza.length; bI++) {
            $("#select-type-pizza").append($("<option>", {
                text: vArrayPizza[bI],
                value: vArrayPizza[bI].toUpperCase(),
            }))
        }

    }
    // filter data table
    function onBtnFilter() {

        // b0 tao obj
        var vObjOrder = {
            trangThai: "",
            loaiPizza: "",
        }
        // b1 thu thap thong tin
        getDataFilter(vObjOrder);
        console.log(vObjOrder);
        // b2 kiem tra thong tin(bo qua)
        // b3 xu ly filter
        var vDataResult = getHandleFilter(vObjOrder);
        // // b4 hien thi 
        loadDataToTable(vDataResult);
    }
    // data modal
    function onBtnUpdateModalConfirm() {
        console.log(gId);
        console.log(gOrderCode);
        var vObjModal = {
            trangThai: "confirmed",
        }
        // b1 thu thap thong tin
        // b2 kiem tra thong tin
        $.ajax({
            url: gBASE_URL + "/" + gId,
            type: "PUT",
            data: JSON.stringify(vObjModal),
            contentType: gCONTENT_TYPE,
            success: function (paramRes) {
                console.log(paramRes);
                handelUpdateComfirm();
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }

        })

    }
    // update trang thai cancel
    function onBtnUpdateModalCancel() {

        var vObjModal = {
            trangThai: "cancel",
        }
        // b1 thu thap thong tin
        // b2 kiem tra thong tin
        $.ajax({
            url: gBASE_URL + "/" + gId,
            type: "PUT",
            data: JSON.stringify(vObjModal),
            contentType: gCONTENT_TYPE,
            success: function (paramRes) {
                console.log(paramRes);
                handelUpdateComfirm();
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }

        })

    }

    function onLoadDataModal() {
        $.ajax({
            url: gBASE_URL + "/" + gOrderCode,
            type: "GET",
            success: function (paramRes) {
                console.log(paramRes);
                fillDataModal(paramRes);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        })
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    // thu thap thong tin filter
    function getDataFilter(paramObj) {
        paramObj.trangThai = $("#select-status").val();
        paramObj.loaiPizza = $("#select-type-pizza").val();
    }
    // loc du lieu (filter data)
    function getHandleFilter(paramObj) {

        var vArrayResult = [];
        vArrayResult = gDataOrder.filter(function (item) {
            return item.trangThai.toUpperCase() === paramObj.trangThai.toUpperCase()
                && item.loaiPizza === paramObj.loaiPizza.toUpperCase();

        })
        console.log(vArrayResult);

        return vArrayResult;
    }
    // thu thap thong tin modal

    function loadDataToTable(paramData) {
        var vTable = $("#table-order").DataTable();
        vTable.clear();
        vTable.rows.add(paramData);
        vTable.draw();
    }
    // getData button table
    function getDataButtonTable(paramElement) {
        var vTable = $("#table-order").DataTable();
        var vRow = paramElement.closest("tr");
        var vDataRow = vTable.row(vRow).data();
        return vDataRow;
    }
    // load drink
    function onLoadDrink() {
        $.ajax({
            url: gBASE_URL_DRINk,
            type: "GET",
            success: function (paramRes) {
                console.log(paramRes);
                selectedDrink(paramRes);
            },
            error: function (paramErr) {
                console.log(paramErr.status);
            }
        })
    }
    function selectedDrink(paramRes) {
        for (var bI = 0; bI < paramRes.length; bI++) {
            $("#select-drink").append($("<option>", {
                text: paramRes[bI].tenNuocUong,
                value: paramRes[bI].maNuocUong,
            }))
        }

    }
    function fillDataModal(parmRes) {
        $("#inp-order-code").val(parmRes.orderCode);
        $("#select-size option:selected").text(parmRes.kichCo);
        $("#inp-duong-kinh").val(parmRes.duongKinh);
        $("#inp-suon").val(parmRes.suon);
        $("#inp-salad").val(parmRes.salad);
        $("#inp-loai-pizza").val(parmRes.loaiPizza);
        $("#inp-id-voucher").val(parmRes.idVourcher);
        $("#inp-thanh-tien").val(parmRes.thanhTien);
        $("#inp-giam-gia").val(parmRes.giamGia);
        $("#select-drink option:selected").text(parmRes.idLoaiNuocUong);
        $("#inp-so-luong-nuoc").val(parmRes.soLuongNuoc);
        $("#inp-ho-ten").val(parmRes.hoTen);
        $("#inp-email").val(parmRes.email);
        $("#inp-so-dien-thoai").val(parmRes.soDienThoai);
        $("#inp-dia-chi").val(parmRes.diaChi);
        $("#inp-loi-nhan").val(parmRes.loiNhan);
        $("#inp-ngay-order").val(parmRes.ngayTao);
        $("#inp-ngay-sua").val(parmRes.ngayCapNhat);

    }
    function handelUpdateComfirm() {
        alert("update thành công!");
        location.reload();
        $("modal-detail").modal().hide;
    }

</script>

</html>